unit FileRWLib_TLB;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //
// LIBID: {F5B3D3D3-9476-43EB-9A15-10A88125A5EB}
// LCID: 0
// Helpfile: 
// HelpString: FileRWLib Library
// DepndLst: 
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows,SysUtils, ActiveX, Classes, Graphics, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  FileRWLibMajorVersion = 1;
  FileRWLibMinorVersion = 0;

  LIBID_FileRWLib: TGUID = '{F5B3D3D3-9476-43EB-9A15-10A88125A5EB}';

  IID_IFileDataSet: TGUID = '{87DBD02A-ABC9-4D4B-B951-2A4F15E88FE9}';
  CLASS_FileDataSet: TGUID = '{CF07E823-1AE2-497E-81E7-4F3880CA387F}';
type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IFileDataSet = interface;
  IFileDataSetDisp = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  FileDataSet = IFileDataSet;
  TDbProcItem = class;
  TDbProcParamItemClass = class of TDbProcParamItem;
  TDbProcItemClass      = class of TDbProcItem;
  
  TProcParamIOType      = (pmInput,pmResult);
  TCallTriggerTiming    = ( trgDisabled
                           ,trgBeforeInsert ,trgAfterInsert
                           ,trgBeforeEdit   ,trgAfterEdit
                           ,trgBeforeDelete ,trgAfterDelete
                           ,trgBeforePost   ,trgAfterPost
                           ,trgBeforeScroll ,trgAfterScroll);
  
  TAfterRecDataSetDataChangeEvent = procedure of Object;

  TDbProcItemEvent = procedure (Sender:TDbProcItem;CallUser:string
                                ;var AbortNextStep:boolean) of Object;
 
  TDbProcParamItem = class(TCollectionItem)
  Private
    FDisPlayName:string;
    FParamDesc  :string;
    FParamValue :string;
    FParamIOType:TProcParamIOType;
    procedure SetFParamDesc  (const Value: string);
    procedure SetFParamValue (const Value: string);
    procedure SetFParamIOType(const Value: TProcParamIOType);
  Protected
    function    GetParamStateStr:string;
    function    GetDisplayName: string; Override;
    procedure   SetDisplayName(const Value: string); Override;
  Public
    Constructor Create(Collection:TCollection); Override;
    Destructor  Destroy; Override;
    procedure   Assign(Source: TPersistent); Override;
  Published
    property Descrip:string read FParamDesc write SetFParamDesc;
    property Value:string read FParamValue write SetFParamValue;
    property InOutType:TProcParamIOType read  FParamIOType
                                        write SetFParamIOType Default pmInput;
  end;

  TDbProcParams = Class(TOwnedCollection)
  private
    procedure   SetDbProcParamItem(Index:Integer;value:TDbProcParamItem);
    function    GetDbProcParamItem(Index:Integer):TDbProcParamItem;
  protected
    OwnerProc:TDbProcItem;
    function    GetCount:Integer;
  Public
    Constructor Create(TheOwner:TComponent;ItemClass:TDbProcParamItemClass);
    Destructor  Destroy; Override;
    function    Add:TDbProcParamItem;
    property    Params[Index: Integer]:TDbProcParamItem
                read  GetDbProcParamItem write SetDbProcParamItem;
  end;

  TDbProcItem = class(TCollectionItem)
  Private
    FDisPlayName:string;
    FProcDescrip:string;
    FBeATrigger:boolean;
    FTriggerTime:TCallTriggerTiming;
    FProcParams:TDbProcParams;
    FOnExecuteProc:TDbProcItemEvent;
    procedure SetFProcDescrip(const Value: string);
    procedure SetFBeATrigger(const Value: boolean);
    procedure SetFTriggerTime(const Value: TCallTriggerTiming);
  Protected
    function    GetProcStateStr:string;
    function    GetDisplayName: string; Override;
    procedure   SetDisplayName(const Value: string); Override;
  Public
    Constructor Create(Collection:TCollection); Override;
    Destructor  Destroy; Override;
    procedure   Assign(Source: TPersistent); Override;
    procedure   SetUpItem(Source:TDbProcItem);
    function    ExecuteProc( var ErrMsg:string
                            ;var AbortNextStep:boolean):boolean;
    function    ParamByDesc(ParamDesc:string):TDbProcParamItem;
  Published
    property TriggerTime:TCallTriggerTiming read  FTriggerTime
                                write SetFTriggerTime Default trgDisabled;
    property BeATrigger:boolean read FBeATrigger
                                write SetFBeATrigger Default FALSE;
    property ProcDescrip:string read FProcDescrip write SetFProcDescrip;
    property ProcParams:TDbProcParams read FProcParams write FProcParams;

    property OnExecuteProc:TDbProcItemEvent read  FOnExecuteProc
                                            write FOnExecuteProc;
  end;

  TDbMethods = Class(TOwnedCollection)
  private
    procedure   SetDbProcItem(Index:Integer;value:TDbProcItem);
    function    GetDbProcItem(Index: Integer):TDbProcItem;
  protected
    function    GetCount:Integer;
  Public
    Constructor Create(TheOwner:TComponent;ItemClass:TDbProcItemClass);
    Destructor  Destroy; Override;
    function    Add:TDbProcItem;

    property    Process[Index: Integer]:TDbProcItem
                read  GetDbProcItem write SetDbProcItem;
  end;

// *********************************************************************//
// Interface: IFileDataSet
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {87DBD02A-ABC9-4D4B-B951-2A4F15E88FE9}
// *********************************************************************//
  IFileDataSet = interface(IDispatch)
    ['{87DBD02A-ABC9-4D4B-B951-2A4F15E88FE9}']
    procedure SetFAfterRecDataSetDataChange(inProc:TAfterRecDataSetDataChangeEvent);
    procedure SetFInitDataControlData(inProc:TAfterRecDataSetDataChangeEvent);
    procedure SetFDBStateChange(inProc:TAfterRecDataSetDataChangeEvent);
    procedure SetFUseFilterChange(inProc:TAfterRecDataSetDataChangeEvent);
    function  InitAspFileDBMethod(inMethodOwner:TOwnedCollection):boolean;
    //**********************************************************************
    procedure OnStartPage(const AScriptingContext: IUnknown); safecall;
    procedure OnEndPage; safecall;
    procedure Open(out Success: OleVariant); safecall;
    procedure Close; safecall;
    function  Get_AccessUser: OleVariant; safecall;
    procedure Set_AccessUser(Value: OleVariant); safecall;
    function  Get_AccessFile: OleVariant; safecall;
    procedure Set_AccessFile(Value: OleVariant); safecall;
    procedure AddNewField(FieldName: OleVariant; Size: OleVariant; IsKey: OleVariant; 
                          CanNull: OleVariant; IsUniCodeField: OleVariant; 
                          IsLookUpField: OleVariant; const LookUpDataSet: IFileDataSet; 
                          MasterFieldName: OleVariant; LookUpKeyField: OleVariant; 
                          LookUpResultField: OleVariant; out Success: OleVariant); safecall;
    function  Get_IsBof: OleVariant; safecall;
    function  Get_IsEof: OleVariant; safecall;
    function  Get_IsEmpty: OleVariant; safecall;
    function  Get_RecordCount: OleVariant; safecall;
    function  Get_FieldCount: OleVariant; safecall;
    procedure RecFirst; safecall;
    procedure RecPrior; safecall;
    procedure RecNext; safecall;
    procedure RecLast; safecall;
    procedure RecInsert; safecall;
    procedure RecEdit; safecall;
    procedure RecDelete; safecall;
    procedure RecFind(KeyValue: OleVariant; out Success: OleVariant); safecall;
    procedure RecPost(out Success: OleVariant); safecall;
    function  Get_DbState: OleVariant; safecall;
    function  Get_FieldName(Index: OleVariant): OleVariant; safecall;
    function  Get_FieldByName(FieldName: OleVariant): OleVariant; safecall;
    procedure Set_FieldByName(FieldName: OleVariant; Value: OleVariant); safecall;
    function  Get_IsOpened: OleVariant; safecall;
    procedure AddDetailDb(const DataSetOBJ: FileDataSet; MasterKeyField: OleVariant; 
                          DetailForginKeyField: OleVariant; MultiFieldRelation: OleVariant; 
                          out IsSuccess: OleVariant); safecall;
    function  Get_DetailDbCount: OleVariant; safecall;
    function  Get_IsDetailDB: OleVariant; safecall;
    function  Get_UseFilter: OleVariant; safecall;
    procedure Set_UseFilter(Value: OleVariant); safecall;
    function  Get_DataFilterCount: OleVariant; safecall;
    procedure CreateTable(out IsSuccess: OleVariant); safecall;
    function  Get_IsKeyField(FieldName: OleVariant): OleVariant; safecall;
    function  Get_IsDataField(FieldName: OleVariant): OleVariant; safecall;
    procedure RecCancel; safecall;
    function  Get_GetBookMark: OleVariant; safecall;
    procedure GoToBookMark(BookMark: OleVariant); safecall;
    function  Get_CursorNextRecord: OleVariant; safecall;
    function  Get_CursorPriorRecord: OleVariant; safecall;
    procedure CursorGoToBookMark(BookMark: OleVariant); safecall;
    function  AddNewDataFilterItem(FilterName: OleVariant; DataCompareType: OleVariant;
                                   TargetFieldName: OleVariant; StartValueStrNo: OleVariant;
                                   EndValueStrNo: OleVariant; CompareDataStr: OleVariant): OleVariant; safecall;
    function  DeleteDataFilterItem(FilterItemName: OleVariant): OleVariant; safecall;
    procedure DeleteAllDataFilters; safecall;
    function  LockCurrentRecord(LockReasonStr: OleVariant): OleVariant; safecall;
    function  UnLockCurrentRecord: OleVariant; safecall;
    function  Get_FieldDataSize(FieldName: OleVariant): OleVariant; safecall;
    procedure SaveSchema(FileName: OleVariant); safecall;
    function  AddDataFilterWithCommandStr(CommandStr: OleVariant): OleVariant; safecall;
    function  LoadSchema(FileName: OleVariant): OleVariant; safecall;
    function  InitFieldsWithSchemaStr(SchemaStr: OleVariant): OleVariant; safecall;
    function  IsThisFieldExists(FieldName: OleVariant): OleVariant; safecall;
    function  Get_CompressData: OleVariant; safecall;
    procedure Set_CompressData(Value: OleVariant); safecall;
    function  Get_EncryptData: OleVariant; safecall;
    procedure Set_EncryptData(Value: OleVariant); safecall;
    function  DataFileSize: OleVariant; safecall;
    function  FindData(KeyDataStr: OleVariant): OleVariant; safecall;
    procedure RefreshAllDetailDBData; safecall;
    function  Get_IsReadOnly: OleVariant; safecall;
    procedure Set_IsReadOnly(Value: OleVariant); safecall;
    function  GetVersion: OleVariant; safecall;
    function  CurrentRecordIsChanged: OleVariant; safecall;
    function  GetPhysicalBookMark: OleVariant; safecall;
    function  CombineDataFromFile(DataFileName: OleVariant): OleVariant; safecall;
    function  DeleteField(FieldName: OleVariant): OleVariant; safecall;
    function  DeleteAllFields: OleVariant; safecall;
    procedure SetSchemaFileName(SchemaFileName: OleVariant); safecall;
    function  GetAccessOBJ: OleVariant; safecall;
    function  CreateAccessOBJ: OleVariant; safecall;
    function  KeyFieldCount: OleVariant; safecall;
    function  Get_OrderByDesc: OleVariant; safecall;
    procedure Set_OrderByDesc(Value: OleVariant); safecall;
    function  Get_IsNotNullField(FieldName: OleVariant): OleVariant; safecall;
    procedure ClearAllFieldsData; safecall;
    function  Get_CursorIsBof: OleVariant; safecall;
    function  Get_CursorIsEof: OleVariant; safecall;
    function  Get_IsUniCodeField(FieldName: OleVariant): OleVariant; safecall;
    function  Get_FieldByNameW(FieldName: OleVariant): WideString; safecall;
    procedure Set_FieldByNameW(FieldName: OleVariant; const Value: WideString); safecall;
    procedure ChangeFieldName(OldFieldName: OleVariant; NewFieldName: OleVariant; 
                              out IsSuccess: OleVariant); safecall;
    function  FindDataWithFilter(KeyData: OleVariant; MoveCursor: OleVariant): OleVariant; safecall;
    function  CurrentRecordKeyDataStr: OleVariant; safecall;
    procedure GetFieldDataScopeID(FieldName: OleVariant; out CharStartID: OleVariant; 
                                  out CharEndID: OleVariant); safecall;
    function GetMetaDtaWithFilterByRecNo(MemRecNo: OleVariant): OleVariant; safecall;
    property AccessUser: OleVariant read Get_AccessUser write Set_AccessUser;
    property AccessFile: OleVariant read Get_AccessFile write Set_AccessFile;
    property IsBof: OleVariant read Get_IsBof;
    property IsEof: OleVariant read Get_IsEof;
    property IsEmpty: OleVariant read Get_IsEmpty;
    property RecordCount: OleVariant read Get_RecordCount;
    property FieldCount: OleVariant read Get_FieldCount;
    property DbState: OleVariant read Get_DbState;
    property FieldName[Index: OleVariant]: OleVariant read Get_FieldName;
    property FieldByName[FieldName: OleVariant]: OleVariant read Get_FieldByName write Set_FieldByName;
    property IsOpened: OleVariant read Get_IsOpened;
    property DetailDbCount: OleVariant read Get_DetailDbCount;
    property IsDetailDB: OleVariant read Get_IsDetailDB;
    property UseFilter: OleVariant read Get_UseFilter write Set_UseFilter;
    property DataFilterCount: OleVariant read Get_DataFilterCount;
    property IsKeyField[FieldName: OleVariant]: OleVariant read Get_IsKeyField;
    property IsDataField[FieldName: OleVariant]: OleVariant read Get_IsDataField;
    property GetBookMark: OleVariant read Get_GetBookMark;
    property CursorNextRecord: OleVariant read Get_CursorNextRecord;
    property CursorPriorRecord: OleVariant read Get_CursorPriorRecord;
    property FieldDataSize[FieldName: OleVariant]: OleVariant read Get_FieldDataSize;
    property CompressData: OleVariant read Get_CompressData write Set_CompressData;
    property EncryptData: OleVariant read Get_EncryptData write Set_EncryptData;
    property IsReadOnly: OleVariant read Get_IsReadOnly write Set_IsReadOnly;
    property OrderByDesc: OleVariant read Get_OrderByDesc write Set_OrderByDesc;
    property IsNotNullField[FieldName: OleVariant]: OleVariant read Get_IsNotNullField;
    property CursorIsBof: OleVariant read Get_CursorIsBof;
    property CursorIsEof: OleVariant read Get_CursorIsEof;
    property IsUniCodeField[FieldName: OleVariant]: OleVariant read Get_IsUniCodeField;
    property FieldByNameW[FieldName: OleVariant]: WideString read Get_FieldByNameW write Set_FieldByNameW;
  end;

// *********************************************************************//
// DispIntf:  IFileDataSetDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {87DBD02A-ABC9-4D4B-B951-2A4F15E88FE9}
// *********************************************************************//
  IFileDataSetDisp = dispinterface
    ['{87DBD02A-ABC9-4D4B-B951-2A4F15E88FE9}']
    procedure OnStartPage(const AScriptingContext: IUnknown); dispid 1;
    procedure OnEndPage; dispid 2;
    procedure Open(out Success: OleVariant); dispid 5;
    procedure Close; dispid 6;
    property AccessUser: OleVariant dispid 7;
    property AccessFile: OleVariant dispid 8;
    procedure AddNewField(FieldName: OleVariant; Size: OleVariant; IsKey: OleVariant; 
                          CanNull: OleVariant; IsUniCodeField: OleVariant; 
                          IsLookUpField: OleVariant; const LookUpDataSet: IFileDataSet; 
                          MasterFieldName: OleVariant; LookUpKeyField: OleVariant; 
                          LookUpResultField: OleVariant; out Success: OleVariant); dispid 9;
    property IsBof: OleVariant readonly dispid 11;
    property IsEof: OleVariant readonly dispid 12;
    property IsEmpty: OleVariant readonly dispid 13;
    property RecordCount: OleVariant readonly dispid 14;
    property FieldCount: OleVariant readonly dispid 15;
    procedure RecFirst; dispid 16;
    procedure RecPrior; dispid 17;
    procedure RecNext; dispid 18;
    procedure RecLast; dispid 19;
    procedure RecInsert; dispid 21;
    procedure RecEdit; dispid 22;
    procedure RecDelete; dispid 23;
    procedure RecFind(KeyValue: OleVariant; out Success: OleVariant); dispid 24;
    procedure RecPost(out Success: OleVariant); dispid 25;
    property DbState: OleVariant readonly dispid 26;
    property FieldName[Index: OleVariant]: OleVariant readonly dispid 3;
    property FieldByName[FieldName: OleVariant]: OleVariant dispid 4;
    property IsOpened: OleVariant readonly dispid 10;
    procedure AddDetailDb(const DataSetOBJ: FileDataSet; MasterKeyField: OleVariant; 
                          DetailForginKeyField: OleVariant; MultiFieldRelation: OleVariant; 
                          out IsSuccess: OleVariant); dispid 20;
    property DetailDbCount: OleVariant readonly dispid 27;
    property IsDetailDB: OleVariant readonly dispid 28;
    property UseFilter: OleVariant dispid 29;
    property DataFilterCount: OleVariant readonly dispid 30;
    procedure CreateTable(out IsSuccess: OleVariant); dispid 31;
    property IsKeyField[FieldName: OleVariant]: OleVariant readonly dispid 32;
    property IsDataField[FieldName: OleVariant]: OleVariant readonly dispid 33;
    procedure RecCancel; dispid 34;
    property GetBookMark: OleVariant readonly dispid 36;
    procedure GoToBookMark(BookMark: OleVariant); dispid 37;
    property CursorNextRecord: OleVariant readonly dispid 35;
    property CursorPriorRecord: OleVariant readonly dispid 38;
    procedure CursorGoToBookMark(BookMark: OleVariant); dispid 39;
    function AddNewDataFilterItem(FilterName: OleVariant; DataCompareType: OleVariant; 
                                  TargetFieldName: OleVariant; StartValueStrNo: OleVariant; 
                                  EndValueStrNo: OleVariant; CompareDataStr: OleVariant): OleVariant; dispid 40;
    function DeleteDataFilterItem(FilterItemName: OleVariant): OleVariant; dispid 41;
    procedure DeleteAllDataFilters; dispid 42;
    function LockCurrentRecord(LockReasonStr: OleVariant): OleVariant; dispid 43;
    function UnLockCurrentRecord: OleVariant; dispid 44;
    property FieldDataSize[FieldName: OleVariant]: OleVariant readonly dispid 45;
    procedure SaveSchema(FileName: OleVariant); dispid 46;
    function AddDataFilterWithCommandStr(CommandStr: OleVariant): OleVariant; dispid 47;
    function LoadSchema(FileName: OleVariant): OleVariant; dispid 48;
    function InitFieldsWithSchemaStr(SchemaStr: OleVariant): OleVariant; dispid 49;
    function IsThisFieldExists(FieldName: OleVariant): OleVariant; dispid 50;
    property CompressData: OleVariant dispid 51;
    property EncryptData: OleVariant dispid 52;
    function DataFileSize: OleVariant; dispid 53;
    function FindData(KeyDataStr: OleVariant): OleVariant; dispid 54;
    procedure RefreshAllDetailDBData; dispid 55;
    property IsReadOnly: OleVariant dispid 56;
    function GetVersion: OleVariant; dispid 57;
    function CurrentRecordIsChanged: OleVariant; dispid 58;
    function GetPhysicalBookMark: OleVariant; dispid 59;
    function CombineDataFromFile(DataFileName: OleVariant): OleVariant; dispid 60;
    function DeleteField(FieldName: OleVariant): OleVariant; dispid 201;
    function DeleteAllFields: OleVariant; dispid 202;
    procedure SetSchemaFileName(SchemaFileName: OleVariant); dispid 203;
    function GetAccessOBJ: OleVariant; dispid 204;
    function CreateAccessOBJ: OleVariant; dispid 205;
    function KeyFieldCount: OleVariant; dispid 206;
    property OrderByDesc: OleVariant dispid 207;
    property IsNotNullField[FieldName: OleVariant]: OleVariant readonly dispid 208;
    procedure ClearAllFieldsData; dispid 209;
    property CursorIsBof: OleVariant readonly dispid 210;
    property CursorIsEof: OleVariant readonly dispid 211;
    property IsUniCodeField[FieldName: OleVariant]: OleVariant readonly dispid 212;
    property FieldByNameW[FieldName: OleVariant]: WideString dispid 213;
    procedure ChangeFieldName(OldFieldName: OleVariant; NewFieldName: OleVariant; 
                              out IsSuccess: OleVariant); dispid 218;
    function FindDataWithFilter(KeyData: OleVariant; MoveCursor: OleVariant): OleVariant; dispid 214;
    function CurrentRecordKeyDataStr: OleVariant; dispid 215;
    procedure GetFieldDataScopeID(FieldName: OleVariant; out CharStartID: OleVariant; 
                                  out CharEndID: OleVariant); dispid 216;
    function GetMetaDtaWithFilterByRecNo(MemRecNo: OleVariant): OleVariant; dispid 217;
  end;

// *********************************************************************//
// The Class CoFileDataSet provides a Create and CreateRemote method to          
// create instances of the default interface IFileDataSet exposed by              
// the CoClass FileDataSet. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoFileDataSet = class
    class function Create: IFileDataSet;
    class function CreateRemote(const MachineName: string): IFileDataSet;
  end;

implementation

uses ComObj;

class function CoFileDataSet.Create: IFileDataSet;
begin
  Result := CreateComObject(CLASS_FileDataSet) as IFileDataSet;
end;

class function CoFileDataSet.CreateRemote(const MachineName: string): IFileDataSet;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_FileDataSet) as IFileDataSet;
end;

//TDbProcParamItem.
Constructor TDbProcParamItem.Create(Collection: TCollection);
begin
  Inherited Create(Collection);
  self.FParamIOType := pmInput;
  self.SetDisplayName(self.GetParamStateStr);
end;

Destructor TDbProcParamItem.Destroy;
begin
  inherited Destroy;
end;

procedure TDbProcParamItem.Assign(Source: TPersistent);
begin
   if(Source Is TDbProcParamItem)then
     begin
       self.FParamDesc   := TDbProcParamItem(Source).Descrip;
       self.FParamValue  := TDbProcParamItem(Source).Value;
       self.FParamIOType := TDbProcParamItem(Source).InOutType;
     end
   else Inherited Assign(Source);
end;

function TDbProcParamItem.GetDisplayName: string;
begin
  result := self.FDisPlayName;
end;

function TDbProcParamItem.GetParamStateStr: string;
var tmpstr:string;
begin
  result := '';  tmpstr := '';
  if(self.FParamIOType = pmInput)then tmpstr := '< Input > '
  else tmpstr := '( Result ) ';
  if(self.FParamDesc <> '')then
    tmpstr := tmpstr+'Param : '+self.FParamDesc
  else tmpstr := tmpstr+'Param : '+'NewProcParam';
  result := tmpstr;
end;

procedure TDbProcParamItem.SetDisplayName(const Value: string);
begin
  self.FDisPlayName := Value;
end;

procedure TDbProcParamItem.SetFParamDesc(const Value: string);
begin
  FParamDesc := Value;
  self.SetDisplayName(self.GetParamStateStr);
end;

procedure TDbProcParamItem.SetFParamValue(const Value: string);
begin
  FParamValue := Value;
end;

procedure TDbProcParamItem.SetFParamIOType(const Value: TProcParamIOType);
begin
  FParamIOType := Value;
  self.SetDisplayName(self.GetParamStateStr);
end;

//TDbProcParams.
Constructor TDbProcParams.Create(TheOwner: TComponent;
  ItemClass: TDbProcParamItemClass);
begin
  inherited Create(TheOwner,ItemClass);
  self.OwnerProc := TDbProcItem(TheOwner);
end;

Destructor TDbProcParams.Destroy;
begin
  self.OwnerProc := nil;
  inherited Destroy;
end;

function TDbProcParams.Add: TDbProcParamItem;
begin
  result := TDbProcParamItem(inherited Add);
end;

function TDbProcParams.GetCount: Integer;
begin
  result := inherited Count;
end;

function TDbProcParams.GetDbProcParamItem(
  Index: Integer): TDbProcParamItem;
begin
  result := TDbProcParamItem(inherited Items[Index]);
end;

procedure TDbProcParams.SetDbProcParamItem(Index: Integer;
  value: TDbProcParamItem);
begin
  self.Params[Index].Assign(value);
end;

//TDbProcItem.
Constructor TDbProcItem.Create(Collection: TCollection);
begin
  Inherited Create(Collection);
  self.SetDisplayName(self.GetProcStateStr);
  self.FProcParams
    := TDbProcParams.Create( TComponent(TDbMethods(self.GetOwner).GetOwner)
                            ,TDbProcParamItem);
end;

Destructor TDbProcItem.Destroy;
begin
  self.FProcParams.Free;
  inherited Destroy;
end;

procedure TDbProcItem.Assign(Source: TPersistent);
var i:integer;
    tmpDbProcParamItem:TDbProcParamItem;
begin
   if(Source Is TDbProcItem)then
     begin
       self.FProcDescrip   := TDbProcItem(Source).ProcDescrip;
       self.FBeATrigger    := TDbProcItem(Source).BeATrigger;
       self.FTriggerTime   := TDbProcItem(Source).TriggerTime;
       //-----------------------------------------------------
       while self.FProcParams.Count > 0 do
         self.FProcParams.Delete(0);
       //-----------------------------------------------------
       for i := 0 to TDbProcItem(Source).ProcParams.GetCount-1 do
         begin
           tmpDbProcParamItem := self.FProcParams.Add;
           tmpDbProcParamItem.Assign(TDbProcItem(Source).ProcParams.Params[i]);
         end;//for...i...end!!
       tmpDbProcParamItem := nil;
       self.FOnExecuteProc := TDbProcItem(Source).OnExecuteProc;
     end
   else Inherited Assign(Source);
end;

procedure TDbProcItem.SetUpItem(Source:TDbProcItem);
var i:integer;
    tmpDbProcParamItem:TDbProcParamItem;
begin
  self.FProcDescrip   := Source.ProcDescrip;
  self.FBeATrigger    := Source.BeATrigger;
  self.FTriggerTime   := Source.TriggerTime;
  //-------------------------------------------------------------
  while self.FProcParams.Count > 0 do self.FProcParams.Delete(0);
  //-------------------------------------------------------------
  for i := 0 to Source.ProcParams.GetCount-1 do
    begin
      tmpDbProcParamItem := self.FProcParams.Add;
      tmpDbProcParamItem.FParamDesc    := Source.ProcParams.Params[i].Descrip;
      tmpDbProcParamItem.FParamValue   := Source.ProcParams.Params[i].Value;
      tmpDbProcParamItem.FParamIOType  := Source.ProcParams.Params[i].InOutType;
    end;//for...i...end!!
  tmpDbProcParamItem := nil;
  self.FOnExecuteProc := Source.OnExecuteProc;
end;

function TDbProcItem.ExecuteProc(var ErrMsg: string
                                 ;var AbortNextStep:boolean): boolean;
var callUser:string;
begin
  callUser := 'System';
  try
    if(Assigned(self.OnExecuteProc))then
      self.OnExecuteProc(self,callUser,AbortNextStep);
    result := TRUE;
  except
    on e:Exception do
      ErrMsg := e.Message;
  end;//try...end!!
end;

function TDbProcItem.ParamByDesc(ParamDesc: string): TDbProcParamItem;
var i:integer;
begin
  result := nil;
  for i := 0 to self.FProcParams.GetCount-1 do
    begin
      if(self.FProcParams.Params[i].Descrip = ParamDesc)then
        begin
          result := self.FProcParams.Params[i];
          Break;
        end;//if...end!!
    end;//for...i...end!!
end;

function TDbProcItem.GetDisplayName: string;
begin
  result := self.FDisPlayName;
end;

procedure TDbProcItem.SetDisplayName(const Value: string);
begin
  self.FDisPlayName := Value;
end;

function TDbProcItem.GetProcStateStr: string;
var procStr,tmpStr:string;
begin
  result  := '';
  tmpStr  := '';  procStr := '';
  if(self.FBeATrigger = TRUE)then
    begin
      tmpStr := 'DB Trigger - ';
      case self.FTriggerTime of    
        trgDisabled     : tmpStr := tmpStr+'[ *Disabled* ] : ';
        trgBeforeInsert : tmpStr := tmpStr+'[ BeforeInsert ] : ';
        trgAfterInsert  : tmpStr := tmpStr+'[ AfterInsert  ] : ';
        trgBeforeEdit   : tmpStr := tmpStr+'[ BeforeEdit   ] : ';
        trgAfterEdit    : tmpStr := tmpStr+'[ AfterEdit    ] : ';
        trgBeforeDelete : tmpStr := tmpStr+'[ BeforeDelete ] : ';
        trgAfterDelete  : tmpStr := tmpStr+'[ AfterDelete  ] : ';
        trgBeforePost   : tmpStr := tmpStr+'[ BeforePost   ] : ';
        trgAfterPost    : tmpStr := tmpStr+'[ AfterPost    ] : ';
        trgBeforeScroll : tmpStr := tmpStr+'[ BeforeScroll ] : ';
        trgAfterScroll  : tmpStr := tmpStr+'[ AfterScroll  ] : ';
      end;//case...end!!
    end//if...end!!
  else tmpStr := 'DB Procedure : ';
  if(self.FProcDescrip <> '')then procStr := self.FProcDescrip+'( )'
  else
    if(self.FBeATrigger = TRUE)then procStr := 'NewTrigger( )'
    else procStr := 'NewProcedure( )';
  result := tmpstr+procStr;
end;

procedure TDbProcItem.SetFProcDescrip(const Value: string);
begin
  FProcDescrip := Value;
  self.SetDisplayName(GetProcStateStr);
end;

procedure TDbProcItem.SetFBeATrigger(const Value: boolean);
begin
  FBeATrigger := Value;
  self.SetDisplayName(self.GetProcStateStr);
end;

procedure TDbProcItem.SetFTriggerTime(const Value: TCallTriggerTiming);
begin
  FTriggerTime := Value;
  self.SetDisplayName(self.GetProcStateStr);
end;

//TDbMethods.
Constructor TDbMethods.Create(TheOwner: TComponent;
  ItemClass: TDbProcItemClass);
begin
  inherited Create(TheOwner,ItemClass);
end;

Destructor TDbMethods.Destroy; 
begin                            
  inherited Destroy; 
end;

function TDbMethods.Add: TDbProcItem;
begin
  result := TDbProcItem(inherited Add);
end;

function TDbMethods.GetCount: Integer;
begin
  result := inherited Count; 
end;                         

function TDbMethods.GetDbProcItem(Index: Integer): TDbProcItem;
begin
  result := TDbProcItem(inherited Items[Index]);
end;

procedure TDbMethods.SetDbProcItem(Index: Integer; value: TDbProcItem);
begin
  Process[Index].Assign(value);
end;

end.
